/*
 * Copyright (C) 2000-2003 KFA: Andrew Moenk and Alex Scott
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*! \file array.h
   String based array functions. Mainly intended for strings.
*/

#include "cuf-global.h"
#include "strings.h"

#ifndef _ARRAY_H_
# define _ARRAY_H_

/*** String Based Array Functions */

char **array_string_explode (char *string, char sep, char pad);
char **array_string_boundify (char *str, int colwid);
char *array_string_implode (char **array, char *sep, char pad, int defwid);
char **array_string_append (char **array, char *text);
int array_string_search (char **array, char *search);
char **array_string_remove (char **array, void *ptr);
char **array_string_remove_bytext (char **array, char *matchtext,
                                   int allinst);
void array_string_print (char **array);
void array_string_free (char **array);

#endif /* _ARRAY_H_ */
