/*
 * Copyright (C) 2000-2003 KFA: Andrew Moenk and Alex Scott
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*! \file kfaml.h
   A simple XML style tag parser. v0.1
*/

#include "cuf-global.h"
#include "llist.h"
#include "strings.h"
#include "win32lacks.h"

#ifndef _KFAML_H_
# define _KFAML_H_

/*!
   \desc
   A attribute pair.
*/
typedef struct _KFAmlAttr {
	char *key;			//!< The attribute name.
	char *value;			//!< The attribute value.
} KFAmlAttr;

/*!
   \desc
   A Tag.
*/
typedef struct _KFAmlTag {
	char *tagtype; 			//!< The tag type, NULL if plain text.
	char *stream;			//!< Plain text is here, NULL otherwise.
	Llist *attributes;		//!< The list of attributes.
	Llist *children;		//!< The list of children.
	int closetag; //!< Wether this tag was closed or not
} KFAmlTag;

Llist *kfaml_parse (char *stream, char **tags, int depth);
void kfaml_free (Llist *tree);

#endif /* _KFAML_H_ */
