/*
 * Copyright (C) 1999-2003 Alex Scott
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*! \file mimeproc.h
   Basic Mime Encoder/Decoder, v0.1
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cuf-global.h"
#include "win32lacks.h"

#ifndef _MIMEPROC_H_
# define _MIMEPROC_H_

/*!
   \desc
   The mime string structure. You should only need to read the approate
   members after a conversion is made.
*/
typedef struct _MimeString {
	unsigned long blen;	//!< The binary string's length.
	unsigned long bpos;
	char *binstr;		//!< The binary string.
	unsigned long mlen;	//!< The mime string's length.
	unsigned long mpos;
	char *mimestr;		//!< The mime string.
} MimeString;

MimeString *mime_mstr_new (unsigned long blen, char *binstr,
                           unsigned long mlen, char *mimestr);
void mime_mstr_free (MimeString *mstr);
void mime_print (MimeString *mstr);
int mime_encode (MimeString *mstr);
int mime_decode (MimeString *mstr);
int mime_convert (MimeString *mstr);

#endif /* _MIMEPROC_H_ */
