/*
 * Copyright (C) 2000-2003 KFA: Andrew Moenk and Alex Scott
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*! \file strings.h
   String parseing functions.
*/

#include "cuf-global.h"
#include "win32lacks.h"

#ifndef _STRINGS_H_
# define _STRINGS_H_

/*** Search Replace ***/

char *search_replace (char *str, char *mat, char *rep, int allinst);
char *search_replace_env (char *str);
char *slashes_decode (char *str, char *exclude, int decodeliterals);
char *slashes_encode (char *str, char *exclude, char *literals,
                      int hexadecimal);
char *slashed_to_quoted (char *str, char *keepescaped, int doublequotes);
char *quoted_to_slashed (char *str, char *includeescape);


/*** String Processing ***/ 

char *strcasestr (char *phaystack, char *pneedle);
char *strcpyto (char *haystack, int delim);
char *strcpyout (char *haystack, char *acceptlist);
char *strcutout (char *haystack, char *start, char *end);
char *strstripq (char *str);
char *strltrim (char *str);
char *strrtrim (char *str);
char *strtrim (char *str);


/*** Miscellaneous ***/

Comparison alpha_compare (char *a, char *b);

#endif /* _STRINGS_H_ */
